package nl.amis.ejb30.hrm;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import javax.persistence.EntityTransaction;
import javax.persistence.Query;


public class HrmClient {
    public static void main(String[] args) {
       HrmService hrmService = new HrmService();

        Employee allen = hrmService.findEmployee(new Long(7499));
        Employee blake = hrmService.findEmployee(new Long(7698));
        System.out.println("Departments for Allen: "+allen.getDepartment().getDname()+" and Blake "+blake.getDepartment().getDname());
        System.out.println("Are the Departments equal: "+(allen.getDepartment()==blake.getDepartment()?"Equal":"Not equal"));
  
               
       // use the predefined service method for finding all employees
       // and printing all their names
       List<Employee>  emps = hrmService.findAllEmp();
       for (Employee e : emps) { 
         System.out.println(e.getEname()+"("+e.getEmpno()+ ") in Department "+e.getDepartment().getDname());
       }
       
        Department sales = hrmService.findDepartment(new Long(30));
        System.out.println("Sales "+sales.getDname()+" staff:"+sales.getStaff());
        System.out.println("Sales "+sales.getDname()+" staffsize:"+sales.getStaff().size());

        System.out.println("Departments for Allen: "+allen.getDepartment().getDname()+" and Blake "+blake.getDepartment().getDname());
        System.out.println("Are the Departments equal: "+(allen.getDepartment()==blake.getDepartment()?"Equal":"Not equal"));
        System.out.println("Is the Allen object in the Sales Staff collection? "+(sales.getStaff().contains(allen)?"Yes":"No"));
             
       // inside a transaction, create a new employee - persist it - and a new department - and persist it!       
       EntityTransaction tx = hrmService.getEntityManager().getTransaction();
       tx.begin();
       Department toys = new Department();
       toys.setDeptno(new Long(60));
       toys.setDname("Toys");
       toys.setLocation("Zoetermeer");

       Employee tobias = new Employee();
       tobias.setEname("Tobias");
       tobias.setEmpno(new Long(2000));
       tobias.setDepartment(toys);
       hrmService.getEntityManager().persist(tobias);
       
       // Commit the transaction
       tx.commit();
        tx.begin();
        toys.getStaff().remove(tobias);
        tobias.setDepartment(null);
        hrmService.getEntityManager().merge(toys);
        hrmService.getEntityManager().merge(tobias);
        // Commit the transaction
        tx.commit();
        
/*
       // run an EJBQL query selecting a Department by some Search Criterium
       String ejbql = "SELECT d FROM Department d WHERE d.location = :location";  // you can tell this is an EJBQL query 
       // because of the select d from department d - the whole record is selected, instead of individual columns 
       // and it is selected from the Class-name Department , not the Table-name DEPT!
       Query query = hrmService.getEntityManager().createQuery(ejbql);
       query.setParameter("location", "Nieuwegein");
       List<Department> result = query.getResultList();
       // use a little Java 5.0 Autoboxing for simple, elegant for-looping
       for( Department d:result) {
           System.out.println("Department "+d.getDeptno()+"  "+d.getDname());
       }
       */
       // Close this HrmService instance (and implicitly the EntityManager)
       hrmService.shutdown();
    }
}
